#include <iostream>
#include <string>

using namespace std;

int main()
{
	int i,j,N,O,A,B,AB,potrebna[1000000],dobijeno[1000000][4];
	string pacijent[1000];
	cin>>N;
	cin>>O>>A>>B>>AB;
	for(i=0;i<N;i++)
	{
		cin>>pacijent[i];
		cin>>potrebna[i];
		if(pacijent[i]=="O")
		{
			O=O-potrebna[i];
			dobijeno[i][0]=dobijeno[i][0]+potrebna[i];
			
		}else if(pacijent[i]=="A")
		{
			if(potrebna[i]>0)
			{
				while(A>0 && potrebna[i]>0)
				{
					A--;
					potrebna[i]--;
					dobijeno[i][1]++;
			    }
			}
			if(potrebna[i]>0)
			{
				while(potrebna[i]>0)
				{
					O--;
					potrebna[i]--;
					dobijeno[i][0]++;
				}
			}
		}else if(pacijent[i]=="B")
		{
			if(potrebna[i]>0)
			{
				while(B>0 && potrebna[i]>0)
				{
					B--;
					potrebna[i]--;
					dobijeno[i][2]++;
				}
			}
			if(potrebna[i]>0)
			{
				while(potrebna[i]>0)
				{
					O--;
					potrebna[i]--;
					dobijeno[i][0]++;
				}
			}
		}else
		{
			if(potrebna[i]>0)
			{
				while(AB>0 && potrebna[i]>0)
				{
					AB--;
					potrebna[i]--;
					dobijeno[i][3]++;
				}
			}
			if(potrebna[i]>0)
			{
				while(potrebna[i]>0)
				{
					if(A>0 && A>B)
					{
						A--;
						potrebna[i]--;
						dobijeno[i][1]++;
					}else if(B>0)
					{
						B--;
						potrebna[i]--;
						dobijeno[i][2]++;
					}else
					{
						break;
					}
				}
			}
			if(potrebna[i]>0)
			{
				while(potrebna[i]>0)
				{
					O--;
					potrebna[i]--;
					dobijeno[i][0]++;
				}
			}
		}
	}
	if(O>=0)
	{
		cout<<"moguce"<<endl;
		for(i=0;i<N;i++)
		{
			for(j=0;j<4;j++)
			{
				cout<<dobijeno[i][j]<<" ";
			}
			cout<<endl;
		}
	}else
	{
		cout<<"nemoguce";
	}
	return 0;
}